package src.test

import akka.actor.ActorDSL._
import akka.actor.ReceiveTimeout
import java.io.{InputStreamReader, BufferedReader}
import java.net.{Socket, ServerSocket}
import scala.concurrent.duration._
import src.ship._

/**
 * Created with IntelliJ IDEA.
 * User: dodi
 * Date: 18.01.13
 * Time: 09:54
 */

class EmergencyButtonServer(port: Int) extends ActWithStash {
  var runnable: Boolean = true
  var welcomeSocket: ServerSocket = null
  var connectionSocket: Socket = null

  override def preStart() {
    println("Emergency Button Server started *** " + port)
    welcomeSocket = new ServerSocket(port)
    connectionSocket = welcomeSocket.accept()
    context.setReceiveTimeout(100.millisecond)
  }

  override def receive = {
    case ReceiveTimeout => if (runnable) {
      val inFromClient: BufferedReader = new BufferedReader(new InputStreamReader(connectionSocket.getInputStream))
      val clientSentence = inFromClient.readLine()
      System.out.println("Received: " + clientSentence)
      if (clientSentence == "0") SHIPTool.ref ! Update(List[ABoxFormula](ConceptAssertion(Const("situation"), ConceptConstant("Emergency"))), List[Const]())
      else if (clientSentence == "1") SHIPTool.ref ! Update(List[ABoxFormula](ConceptAssertion(Const("situation"), ConceptConstant("Normal"))), List[Const]())
      else println("cannot process input " + clientSentence)
    }
  }

  def stop() {
    println("Stopping EmergencyButton")
    runnable = false
    if (welcomeSocket != null) welcomeSocket.close()
  }
}
