package src.test;

import aterm.ATermAppl;
import com.clarkparsia.pellet.owlapiv3.PelletReasoner;
import org.mindswap.pellet.utils.ATermUtils;
import org.semanticweb.owlapi.apibinding.OWLManager;
import org.semanticweb.owlapi.expression.OWLClassExpressionParser;
import org.semanticweb.owlapi.model.*;
import org.semanticweb.owlapi.reasoner.OWLReasoner;

import java.util.Iterator;
import java.util.Set;

/**
 * Created by IntelliJ IDEA.
 * User: dodi
 * Date: 7/17/12
 * Time: 12:16 PM
 * To change this template use File | Settings | File Templates.
 */
public class InstanceTest2 {
    public static void main(String[] args) throws OWLOntologyCreationException {
        // we load the complete ontology from owl and perform some tests

        OWLOntologyManager manager = OWLManager.createOWLOntologyManager();
        OWLOntology ontology = manager.loadOntology( IRI.create("file:" + "examples/SimpleInf.owl") );
        PelletReasoner reasoner = new PelletReasoner( ontology, org.semanticweb.owlapi.reasoner.BufferingMode.NON_BUFFERING );

        OWLClass set12 = manager.getOWLDataFactory().getOWLClass( IRI.create( "http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#Set12" ) );
        OWLClass set1 = manager.getOWLDataFactory().getOWLClass( IRI.create( "http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#Set1" ) );
        OWLClass set2 = manager.getOWLDataFactory().getOWLClass( IRI.create( "http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#Set2" ) );

        // we extend the initial ontology and try it again....
        ATermAppl newind = ATermUtils.makeTermAppl("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#sX");
        reasoner.getKB().addIndividual( newind );
        reasoner.getKB().addType(newind, ATermUtils.makeTermAppl("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#Set1"));
        reasoner.getKB().addType(newind, ATermUtils.makeTermAppl("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#Set2"));

        // and action...
        reasoner.prepareReasoner();

        Set<OWLNamedIndividual> instances = reasoner.getInstances( set12, false ).getFlattened();

        ATermAppl internSet1 = ATermUtils.makeTermAppl("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#Set1");
        ATermAppl internSet2 = ATermUtils.makeTermAppl("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#Set2");

        ATermAppl internSet12 = ATermUtils.makeAnd(internSet1, internSet2);
        ATermAppl internSet21 = ATermUtils.makeAnd(internSet2, internSet1);
        System.out.println("set2 "+internSet2+" set1 "+internSet1);
        System.out.println("instances of "+internSet1+" "+reasoner.getKB().getInstances( internSet1, false));
        System.out.println("instances of "+internSet2+" "+reasoner.getKB().getInstances( internSet2, false));
        System.out.println("instances of "+internSet12+" "+reasoner.getKB().getInstances( internSet12, false));
        System.out.println("instances of "+internSet21+" "+reasoner.getKB().getInstances( internSet21, false));


        System.out.println(instances);

         try {
                manager.saveOntology(ontology, System.out);
            } catch (OWLOntologyStorageException e) {
                e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
            }

    }
}
