package src.test;

import aterm.ATermAppl;
import com.clarkparsia.pellet.owlapiv3.PelletReasonerFactory;
import org.mindswap.pellet.DependencySet;
import org.mindswap.pellet.utils.ATermUtils;
import org.semanticweb.owlapi.apibinding.OWLManager;

import com.clarkparsia.pellet.owlapiv3.PelletReasoner;
import org.semanticweb.owlapi.apibinding.OWLManager;
import org.semanticweb.owlapi.model.*;
import org.semanticweb.owlapi.reasoner.Node;
import org.semanticweb.owlapi.reasoner.NodeSet;


/**
 * Created by IntelliJ IDEA.
 * User: dodi
 * Date: 7/17/12
 * Time: 2:12 PM
 * To change this template use File | Settings | File Templates.
 */
public class InstanceTest3 {
    public static void main(String[] args) throws OWLOntologyCreationException {
        // we create an empty ontology with namespaces and perform some queries
        OWLOntologyManager manager = OWLManager.createOWLOntologyManager();
        OWLDataFactory factory = manager.getOWLDataFactory();
        //OWLOntology ontology = manager.createOntology(IRI.create("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl"));
        OWLOntology ontology = manager.createOntology();
        PelletReasoner reasoner = new PelletReasoner( ontology, org.semanticweb.owlapi.reasoner.BufferingMode.NON_BUFFERING );

        // we add a class
        reasoner.getKB().addClass(ATermUtils.makeTermAppl("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#Set1"));
        reasoner.getKB().addClass(ATermUtils.makeTermAppl("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#Set2"));


        // we add a property and define a new class
        reasoner.getKB().addObjectProperty(ATermUtils.makeTermAppl("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#At"));
        reasoner.getKB().getRBox().getRole(ATermUtils.makeTermAppl("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#At")).addDomain(ATermUtils.makeTermAppl("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#Set1"), DependencySet.EMPTY);
        reasoner.getKB().getRBox().getRole(ATermUtils.makeTermAppl("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#At")).addRange(ATermUtils.makeTermAppl("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#Set1"), DependencySet.EMPTY);


        reasoner.getKB().addEquivalentClass(ATermUtils.makeTermAppl("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#ExSet"),
                ATermUtils.makeSomeValues(ATermUtils.makeTermAppl("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#At"), ATermUtils.makeTermAppl("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#Set1")));


        // we add an individual
        ATermAppl newind = ATermUtils.makeTermAppl("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#sX");
        reasoner.getKB().addIndividual( newind );
        reasoner.getKB().addType(newind, ATermUtils.makeTermAppl("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#Set1"));
        reasoner.getKB().addType(newind, ATermUtils.makeTermAppl("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#Set2"));
        reasoner.getKB().addPropertyValue(ATermUtils.makeTermAppl("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#At"),
                ATermUtils.makeTermAppl("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#sX"), ATermUtils.makeTermAppl("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#sX"));

        ATermAppl newind2 = ATermUtils.makeTermAppl("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#sY");
        reasoner.getKB().addIndividual( newind2 );
        reasoner.getKB().addType(newind2, ATermUtils.makeTermAppl("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#Set1"));
        reasoner.getKB().addType(newind2, ATermUtils.makeTermAppl("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#Set2"));

        ATermAppl newind3 = ATermUtils.makeTermAppl("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#s1");
        reasoner.getKB().addIndividual( newind3 );
        reasoner.getKB().addType(newind3, ATermUtils.makeTermAppl("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#Set1"));

        ATermAppl newind4 = ATermUtils.makeTermAppl("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#s2");
        reasoner.getKB().addIndividual( newind4);
        reasoner.getKB().addType(newind4, ATermUtils.makeTermAppl("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#Set2"));

        // and action...
        reasoner.prepareReasoner();
        reasoner.getKB().realize();
        reasoner.getKB().printClassTree();

        ATermAppl internSet1 = ATermUtils.makeTermAppl("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#Set1");
        ATermAppl internSet2 = ATermUtils.makeTermAppl("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#Set2");
        ATermAppl exset= ATermUtils.makeTermAppl("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl#ExSet");

        ATermAppl internSet12 = ATermUtils.makeAnd(internSet1, internSet2);
        ATermAppl internSet21 = ATermUtils.makeAnd(internSet2, internSet1);
        System.out.println("instances of "+internSet1+" "+reasoner.getKB().getInstances( internSet1, false));
        System.out.println("instances of "+internSet2+" "+reasoner.getKB().getInstances( internSet2, false));
        System.out.println("instances of "+internSet12+" "+reasoner.getKB().getInstances( internSet12, false));
        System.out.println("instances of "+internSet21+" "+reasoner.getKB().getInstances( internSet21, false));
        System.out.println("instances of "+exset+" "+reasoner.getKB().getInstances( exset, false));




    }
}
