package src.test;


import aterm.AFun;
import aterm.ATerm;
import aterm.ATermAppl;
import aterm.ATermFactory;
import com.clarkparsia.pellet.owlapiv3.PelletReasoner;
import org.mindswap.pellet.DependencySet;
import org.mindswap.pellet.KnowledgeBase;
import org.mindswap.pellet.Role;
import org.mindswap.pellet.utils.ATermUtils;
import org.semanticweb.owlapi.apibinding.OWLManager;
import org.semanticweb.owlapi.model.*;

import java.io.FileWriter;

/**
 * Created by IntelliJ IDEA.
 * User: dodi
 * Date: 7/17/12
 * Time: 4:28 PM
 * To change this template use File | Settings | File Templates.
 */
public class InstanceTest5 {
    public static void main(String[] args) throws OWLOntologyCreationException {
        OWLOntologyManager manager = OWLManager.createOWLOntologyManager();
        OWLDataFactory factory = manager.getOWLDataFactory();
        //OWLOntology ontology = manager.createOntology(IRI.create("http://www.semanticweb.org/ontologies/2012/6/SimpleInf.owl"));
        OWLOntology ontology = manager.createOntology();
        PelletReasoner reasoner = new PelletReasoner(ontology, org.semanticweb.owlapi.reasoner.BufferingMode.NON_BUFFERING);
        //manager.addOntologyChangeListener( reasoner );


        //RBox
        //add Different = ¬SameAs

        //TBox
        //add WheelChair < TransportAssistant
        reasoner.getKB().addClass(ATermUtils.makeTermAppl("TransportAssistant"));
        reasoner.getKB().addClass(ATermUtils.makeTermAppl("WheelChair"));
        reasoner.getKB().addSubClass(ATermUtils.makeTermAppl("WheelChair"), ATermUtils.makeTermAppl("TransportAssistant"));
        //add Free = ¬(∃At⁻¹.TransportAssistant)
        reasoner.getKB().addClass(ATermUtils.makeTermAppl("Free"));
        //add Accessible = (Free⊓¬(∃AccessGranted⁻¹.TransportAssistant))
        reasoner.getKB().addClass(ATermUtils.makeTermAppl("Accessible"));

        //ABox
        //add rolland:WheelChair
        reasoner.getKB().addIndividual( ATermUtils.makeTermAppl("rolland"));
        reasoner.getKB().addType(ATermUtils.makeTermAppl("rolland"), ATermUtils.makeTermAppl("WheelChair"));
        reasoner.getKB().addIndividual( ATermUtils.makeTermAppl("rolland2"));
        reasoner.getKB().addType(ATermUtils.makeTermAppl("rolland2"), ATermUtils.makeTermAppl("WheelChair"));
        //add bath:Position
        reasoner.getKB().addClass(ATermUtils.makeTermAppl("Position"));
        reasoner.getKB().addIndividual( ATermUtils.makeTermAppl("bath"));
        reasoner.getKB().addType(ATermUtils.makeTermAppl("bath"), ATermUtils.makeTermAppl("Position"));
        //add kitchen:Position
        reasoner.getKB().addIndividual( ATermUtils.makeTermAppl("kitchen"));
        reasoner.getKB().addType(ATermUtils.makeTermAppl("kitchen"), ATermUtils.makeTermAppl("Position"));
        //add (rolland, kitchen):At
        //reasoner.getKB().addObjectProperty(ATermUtils.makePropAtom(ATermUtils.makeTermAppl("At"),ATermUtils.makeTermAppl("rolland"), ATermUtils.makeTermAppl("kitchen")));
        // //add (rolland, bath):Next1
        //reasoner.getKB().addObjectProperty(ATermUtils.makePropAtom(ATermUtils.makeTermAppl("Next1"),ATermUtils.makeTermAppl("rolland"), ATermUtils.makeTermAppl("bath")));//add (rolland, bath):RequestAccess
        //reasoner.getKB().addObjectProperty(ATermUtils.makePropAtom(ATermUtils.makeTermAppl("RequestAccess"),ATermUtils.makeTermAppl("rolland"), ATermUtils.makeTermAppl("bath")));


        reasoner.getKB().addObjectProperty(ATermUtils.makeTermAppl("At"));
        reasoner.getKB().getRBox().getRole(ATermUtils.makeTermAppl("At")).addDomain(ATermUtils.makeTermAppl("TransportAssistant"), DependencySet.EMPTY);
        reasoner.getKB().getRBox().getRole(ATermUtils.makeTermAppl("At")).addRange(ATermUtils.makeTermAppl("Position"), DependencySet.EMPTY);

        ATermFactory afactory = new aterm.pure.PureFactory();
        reasoner.getKB().addPropertyValue(ATermUtils.makeTermAppl("At"), ATermUtils.makeTermAppl("rolland"), ATermUtils.makeTermAppl("kitchen"));
        //reasoner.getKB().addPropertyValue(ATermUtils.makeTermAppl("At"), ATermUtils.makeTermAppl("rolland2"), ATermUtils.makeTermAppl("bath"));

        ATermAppl sw = ATermUtils.makeTermAppl("SomeWhere");
        reasoner.getKB().addEquivalentClass(sw, ATermUtils.makeSomeValues(ATermUtils.makeTermAppl("At"), ATermUtils.makeTermAppl("Position")));



        for (Role r : reasoner.getKB().getRBox().getRoles())
            System.out.println(r.getName()+" "+r.getDomains()+" "+r.getType()+" "+r.getRanges()+" ");

          // and action...

        reasoner.getKB().realize();
        reasoner.getKB().printClassTree();
        System.out.println(reasoner.getKB().getClasses());
        System.out.println(reasoner.getKB().getTBox().getAxioms());
        reasoner.prepareReasoner();



        ATermAppl wc= ATermUtils.makeTermAppl("WheelChair");
        ATermAppl tp= ATermUtils.makeTermAppl("TransportAssistant");
        System.out.println("instances of "+wc+" "+reasoner.getKB().getInstances( wc, false));
        System.out.println("instances of "+tp+" "+reasoner.getKB().getInstances( tp, false));
        System.out.println("instances of "+sw+" "+reasoner.getKB().getInstances( sw, false));
        System.out.println(reasoner.getKB().getObjectPropertyValues(ATermUtils.makeTermAppl("At"), ATermUtils.makeTermAppl("rolland")));


    }
}
