package src.test

import java.io.{File, FileReader}
import org.junit.runner.RunWith
import org.scalatest.FunSuite
import org.scalatest.junit.JUnitRunner
import src.ship._
import src.ship.external.{Ontology2Scala, RouteComputation}

/**
 * Created with IntelliJ IDEA.
 * User: dodi
 * Date: 19.09.12
 * Time: 15:46
 */

@RunWith(classOf[JUnitRunner])
class StopPosition extends FunSuite with OntologyParser {

  test("Find distances to allowed stop positions ") {
    parseAll(ontology, new FileReader(new File("examples/baall/transport6.ont"))) match {
      case Success(ont, in) =>
        val points = ont.allIndividuals(ConceptConstant("Position"))
        println(points)
        val stoppoints = ont.allIndividuals(ConceptConstant("StopPosition"))
        val neighbours = Ontology2Scala.RoleEntriesAsList(ont, NamedRole("neighbour"))
        RouteComputation.findClosestStopPosition("pos_294892250", points, neighbours, List(), stoppoints)
      case _ =>
    }
  }
}
