package src.test

import java.io._

import org.coode.owlapi.owlxml.renderer.OWLXMLRenderer
import org.semanticweb.owlapi.apibinding.OWLManager
import org.semanticweb.owlapi.io.{FileDocumentSource, FileDocumentTarget}
import org.semanticweb.owlapi.model.{MissingImportHandlingStrategy, OWLOntologyLoaderConfiguration, OWLOntologyManager, PrefixManager}
import src.ship._

object TestOWL2Onto extends JavaLogging {
  def main(args: Array[String]) {
    val file = new java.io.File("examples/baall/Clothes.owl")
    val optOnto = OWL2Ontology.fromFile(file)
    val pm: PrefixManager = Builtin.prefixManager
    var config = new OWLOntologyLoaderConfiguration()
    config = config.setMissingImportHandlingStrategy(MissingImportHandlingStrategy.SILENT)
    val man: OWLOntologyManager = OWLManager.createOWLOntologyManager()
    optOnto match {
      case None => throw new Exception("No such ontology file.")
      case Some(o) => val onto = o
        println(onto.toStringAux)
        val newOwl = Ontology2OWL.convert(onto, pm, man)
        val newfile = new java.io.File("src/test/newowl.owl")
        val oldfile = new java.io.File("src/test/oldowl.owl")
        val man2 = OWLManager.createOWLOntologyManager()
        val owl = man2.loadOntologyFromOntologyDocument(new FileDocumentSource(file), config)

        man2.saveOntology(owl, new FileDocumentTarget(oldfile))

        val ren = new OWLXMLRenderer()
        val buf = new FileWriter(newfile)
        ren.render(newOwl, buf)
        buf.flush()
        buf.close()

        val diffFile = new java.io.File("src/test/diff.txt")
        val db = new FileWriter(diffFile)

        var diffFunc = "diff "
        if (System.getProperty("file.separator") != "/") diffFunc = "fc "

        val p = Runtime.getRuntime.exec(diffFunc + oldfile.getPath + " " + newfile.getPath)

        val in = p.getInputStream
        var b = in.read
        while (b != -1) {
          db.write(b)
          b = in.read()
        }

        in.close()
        db.flush()
        db.close()
    }
  }
}
