package src.test

import java.io.{File, FileReader}
import org.junit.runner.RunWith
import org.scalatest.FunSuite
import org.scalatest.junit.JUnitRunner
import src.ship.external.{PathCoordination, RouteComputation, Ontology2Scala}
import src.ship.{NamedRole, OntologyParser}

/**
 * Created with IntelliJ IDEA.
 * User: dodi
 * Date: 20.09.12
 * Time: 11:44
 */

@RunWith(classOf[JUnitRunner])
class WCSelection extends FunSuite with OntologyParser {

  test("Find shortest distance of available wheelchairs to subject") {
    parseAll(ontology, new FileReader(new File("examples/baall/transport6assign.ont"))) match {
      case Success(ont, in) =>
        ont.getReasoner
        println(RouteComputation.assignClosestWC(ont, "rpaul"))
      case _ =>
    }
  }

  test("Find neighbours") {
    // Load the wine ontology from the web.
    parseAll(ontology, new FileReader(new File("examples/baall/transport6.ont"))) match {
      case Success(ont, in) =>
        val neighbours = Ontology2Scala.RoleEntriesAsList(ont, NamedRole("neighbour"))
        println(neighbours)
        val current = "pos_294892250"
        val next = neighbours filter {
          case (x, y) => x == current
        }
        val nextpositions: List[String] = (neighbours :\ List[String]())((p, l) => if (p._1 == current) p._2 :: l else l)
        println(nextpositions)
        println(next)
      case _ =>
    }
  }

  test("Coordination") {
    val route1 = Array("Start", "pos_11480149", "pos_296758459", "pos_173120614", "pos_172966766", "Desk")
    val route2 = Array("pos_11160681", "pos_11480149", "pos_294235786", "pos_187911111", "pos_3694646", "BedRight")
    println(PathCoordination.coordinateRoutes(route1, route2))
  }
}
